from urllib.parse import urljoin

from .core import Check
from .registry import register
from ..issues import Issues, Issue
from .. import fetch


@register
class FaviconCheck(Check):
    def run(self):
        issues = Issues()

        try:
            response = fetch.get(urljoin(self.url, "/favicon.ico"))
            response.raise_for_status()
        except Exception as e:
            issues.append(
                Issue.from_type(
                    type="favicon-missing", url=self.url, extra={"exception": str(e)}
                )
            )

        return issues
