from urllib.parse import urlparse

from .core import Check
from ..issues import Issues, Issue
from .registry import register


@register
class UrlPathCheck(Check):
    def run(self):
        issues = Issues()

        parts = urlparse(self.url)

        if " " in parts.path or "%20" in parts.path:
            issues.append(
                Issue.from_type(
                    type="url-contains-space", url=self.url, extra={"url": self.url}
                )
            )

        return issues
