class Setting:
    name = None
    default = None
    # type = None


class SettingsRegistry:
    def __init__(self):
        self._values = {}

    def register(self, setting):
        assert issubclass(setting, Setting), "Setting must be an instance of Setting"
        self._values[setting.name] = setting.default
        return setting

    # TODO may need to implement more dict features (has key, keys, etc.)

    def __setitem__(self, k, v):
        if k not in self._values:
            raise KeyError(f"{k} setting not registered")

        self._values[k] = v
        # TODO could type check here

    def __getitem__(self, k):
        return self._values[k]


Settings = SettingsRegistry()
