from urllib.parse import urlparse


def href_is_url(href):
    allowed_prefixes = ("#", "tel:", "mailto:", "ftp:", "file:")

    for p in allowed_prefixes:
        if href.startswith(p):
            return False

    return True


def url_is_root(url):
    return urlparse(url).path in ("", "/")


def url_is_https(url):
    return urlparse(url).scheme == "https"


def url_is_local(url):
    return urlparse(url).netloc.startswith("127.0.0.1") or urlparse(
        url
    ).netloc.startswith("localhost")
